-- Spam-dash script - From SA1 Spindash: https://mb.srb2.org/threads/sa1-spindash-it-doesnt-matter.28199/

freeslot("sfx_spnnew")
sfxinfo[sfx_spnnew].caption = "Spindash"

local DEFAULT_MINDASH = 20 * FRACUNIT -- Effectively 30 because of the +10 boost
local DEFAULT_MAXDASH = 60 * FRACUNIT

-- Reset spindash values on player spawn
local function resetSpinSpeed(p)
	if p.spectator then return end
	if p.charability2 != CA2_SPINDASH then return end
	if p.sa2noabilities or p.exiting then return end
	
	p.mindash = DEFAULT_MINDASH
	p.maxdash = DEFAULT_MAXDASH
	p.sa2spintime = 0
end

addHook("PlayerSpawn", resetSpinSpeed)

-- Save speed from rolling in spam-dash
local function saveSpinSpeed(p)
	if p.spectator then return end
	if p.charability2 != CA2_SPINDASH then return end
	if p.sa2noabilities or p.exiting then return end
	
	-- Initialize mindash/maxdash value
	if p.mindash < DEFAULT_MINDASH then
		p.mindash = DEFAULT_MAXDASH
	end
	p.maxdash = DEFAULT_MAXDASH
	
	-- Save speed when spinning
	if (p.pflags & PF_STARTDASH) then
		p.sa2spintime = p.realtime
	elseif (p.pflags & PF_SPINNING)  then
		p.mindash = p.speed
		p.sa2spintime = p.realtime
	end
	
	-- Speed is lost when not spinning
	if p.sa2spintime and p.realtime > p.sa2spintime then
		p.mindash = DEFAULT_MINDASH
	end
	
	-- Cap mindash values
	if p.mindash > p.maxdash then p.mindash = p.maxdash end
	if p.mindash < DEFAULT_MINDASH then p.mindash = DEFAULT_MINDASH end
end

addHook("PlayerThink", saveSpinSpeed)

-- Implement spamdash lol
local function spamDash(p)
	if p.spectator then return end
	if p.charability2 != CA2_SPINDASH then return end
	if p.sa2noabilities or p.exiting then return end
	
	-- Changes for SA2:Blast: Start at 30fu, takes 1s to charge to full 70fu
	if p.mo.state == S_PLAY_SPINDASH and not P_IsObjectOnGround(p.mo) then
		p.mo.state = S_PLAY_ROLL
	end
	if (p.pflags & PF_STARTDASH) then
		if p.sa2startdash == 0 then p.mindash = $ + (10 * FRACUNIT) end
		p.sa2startdash = $ + 1
		p.dashspeed = p.mindash + (((DEFAULT_MAXDASH - DEFAULT_MINDASH) / TICRATE) * p.sa2startdash)
		if p.sa2startdash > TICRATE then p.dashspeed = p.maxdash end
		if p.dashspeed > DEFAULT_MAXDASH then p.dashspeed = DEFAULT_MAXDASH end 
		if p.dashspeed != p.mindash and p.dashspeed != p.maxdash and p.realtime % 5 == 0 then
			S_StartSound(p.mo, sfx_spnnew)
		end
		S_StopSoundByID(p.mo, sfx_spndsh)
	else
		p.sa2startdash = 0
	end
	
	-- Fixed for scale
	if (p.speed > FixedMul(5 * FRACUNIT, p.mo.scale) and p.pflags & PF_STARTDASH) then return true end
	
	if P_IsObjectOnGround(p.mo) and p.mo.state != S_PLAY_SPINDASH
	and p.charability2 == CA2_SPINDASH and not (p.pflags & (PF_USEDOWN | PF_SPINNING))
	and (p.sa2speedpad == nil or leveltime >= p.sa2speedpad + (TICRATE / 2)) then
		p.cmomx = 5 * cos(p.mo.angle)
		p.cmomy = 5 * sin(p.mo.angle)
		p.mo.cmomx = p.cmomx
		p.mo.cmomy = p.cmomy
		p.dashspeed = p.mindash
		p.mo.state = S_PLAY_SPINDASH
		p.pflags = $ | (PF_USEDOWN | PF_STARTDASH | PF_SPINNING)
		-- S_StartSound(p.mo, sfx_spndsh)
		return true
	end
	
	if P_IsObjectOnGround(p.mo) and p.pflags & PF_SPINNING and p.mo.state == S_PLAY_ROLL
	and not (p.pflags & (PF_USEDOWN | PF_STARTDASH)) then
		-- p.mo.state = S_PLAY_RUN
		-- p.pflags = ($ & ~PF_SPINNING) | PF_USEDOWN
		p.mo.state = S_PLAY_SPINDASH
		p.pflags = $ | (PF_USEDOWN | PF_STARTDASH | PF_SPINNING)
		return true
	end
end	

addHook("SpinSpecial", spamDash)

/*
local function printSpinSpeed(p)
	local d1 = tostring(p.mindash / FRACUNIT)
	local d2 = tostring(p.maxdash / FRACUNIT)
	local d3 = tostring(p.dashspeed / FRACUNIT)
	local d4 = tostring(p.sa2spintime / TICRATE)
	print(d1 .. " " .. d2 .. " " .. d3 .. " " .. d4)
end

addHook("PlayerThink", printSpinSpeed)
*/