-- Global SA2:Blast functions

-- Are these two objects colliding on the z-axis?
local function zCollide(thing, tmthing)
	if tmthing.z == thing.z then
		return true
	elseif tmthing.z > thing.z then
		return (thing.z + thing.height) > tmthing.z
	elseif tmthing.z < thing.z then
		return (tmthing.z + tmthing.height) > thing.z
	end
end

if SA2B_zCollide == nil then
	rawset(_G, "SA2B_zCollide", zCollide)
end

-- Get the distance between two 3D points
local function calculate_distance(coord1, coord2)
	local xdiff = ((coord1[1] / FRACUNIT) - (coord2[1] / FRACUNIT))^2
	local ydiff = ((coord1[2] / FRACUNIT) - (coord2[2] / FRACUNIT))^2
	local zdiff = ((coord1[3] / FRACUNIT) - (coord2[3] / FRACUNIT))^2
	local result = FixedSqrt(xdiff + ydiff + zdiff)
    return result
end

if SA2B_calculate_distance == nil then
	rawset(_G, "SA2B_calculate_distance", calculate_distance)
end

-- Can player destroy an object? (Like a crate)
local function destroyObjectNormal(p)
	if not (p and p.valid) then return end
	local tempCrawla = P_SpawnMobj(0, 0, FRACUNIT, MT_BLUECRAWLA)
	local returnvalue = P_PlayerCanDamage(p, tempCrawla)
	P_RemoveMobj(tempCrawla)
	local gammaCond = (p.mo.skin == "gamma") and (p.cmd.buttons & BT_USE)
	return returnvalue or gammaCond
end

if SA2B_destroyObjectNormal == nil then
	rawset(_G, "SA2B_destroyObjectNormal", destroyObjectNormal)
end
